/* Generated by Frama-C */
#include "stddef.h"
#include "stdint.h"
#include "stdio.h"
#include "stdlib.h"
extern  __attribute__((__FC_BUILTIN__)) int __e_acsl_sound_verdict;

int *X;
int Z;
/*@ requires \valid(x);
    ensures \valid(\result); */
int *__gen_e_acsl_f(int *x);

int *f(int *x)
{
  int *y;
  __e_acsl_store_block((void *)(& y),(size_t)8);
  {
    int __gen_e_acsl_initialized;
    int __gen_e_acsl_and;
    __e_acsl_store_block((void *)(& x),(size_t)8);
    __e_acsl_assert_data_t __gen_e_acsl_assert_data = {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data,"&y",
                                 (void *)(& y));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data,
                                   "sizeof(int *)",0,sizeof(int *));
    __gen_e_acsl_initialized = __e_acsl_initialized((void *)(& y),
                                                    sizeof(int *));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,
                                 "\\initialized(&y)",0,
                                 __gen_e_acsl_initialized);
    if (__gen_e_acsl_initialized) {
      int __gen_e_acsl_valid;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data,"y",(void *)y);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data,
                                     "sizeof(int)",0,sizeof(int));
      __gen_e_acsl_valid = __e_acsl_valid((void *)y,sizeof(int),(void *)y,
                                          (void *)(& y));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,"\\valid(y)",0,
                                   __gen_e_acsl_valid);
      __gen_e_acsl_and = __gen_e_acsl_valid;
    }
    else __gen_e_acsl_and = 0;
    __gen_e_acsl_assert_data.blocking = 1;
    __gen_e_acsl_assert_data.kind = "Assertion";
    __gen_e_acsl_assert_data.pred_txt = "!\\valid(y)";
    __gen_e_acsl_assert_data.file = "tests/memory/valid.c";
    __gen_e_acsl_assert_data.fct = "f";
    __gen_e_acsl_assert_data.line = 13;
    __e_acsl_assert(! __gen_e_acsl_and,& __gen_e_acsl_assert_data);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data);
  }
  /*@ assert !\valid(y); */ ;
  __e_acsl_full_init((void *)(& y));
  y = x;
  {
    int __gen_e_acsl_valid_2;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_2 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_2,"x",(void *)x);
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_2,
                                   "sizeof(int)",0,sizeof(int));
    __gen_e_acsl_valid_2 = __e_acsl_valid((void *)x,sizeof(int),(void *)x,
                                          (void *)(& x));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_2,"\\valid(x)",0,
                                 __gen_e_acsl_valid_2);
    __gen_e_acsl_assert_data_2.blocking = 1;
    __gen_e_acsl_assert_data_2.kind = "Assertion";
    __gen_e_acsl_assert_data_2.pred_txt = "\\valid(x)";
    __gen_e_acsl_assert_data_2.file = "tests/memory/valid.c";
    __gen_e_acsl_assert_data_2.fct = "f";
    __gen_e_acsl_assert_data_2.line = 15;
    __e_acsl_assert(__gen_e_acsl_valid_2,& __gen_e_acsl_assert_data_2);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_2);
  }
  /*@ assert \valid(x); */ ;
  __e_acsl_delete_block((void *)(& x));
  __e_acsl_delete_block((void *)(& y));
  return y;
}

void g(void)
{
  int m;
  int *u;
  int **p;
  __e_acsl_store_block((void *)(& p),(size_t)8);
  __e_acsl_store_block((void *)(& u),(size_t)8);
  __e_acsl_store_block((void *)(& m),(size_t)4);
  __e_acsl_full_init((void *)(& p));
  p = & u;
  __e_acsl_full_init((void *)(& u));
  u = & m;
  __e_acsl_full_init((void *)(& m));
  m = 123;
  {
    int __gen_e_acsl_initialized;
    int __gen_e_acsl_and_2;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data = {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data,"p",(void *)p);
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data,
                                   "sizeof(int *)",0,sizeof(int *));
    __gen_e_acsl_initialized = __e_acsl_initialized((void *)p,sizeof(int *));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,
                                 "\\initialized(p)",0,
                                 __gen_e_acsl_initialized);
    if (__gen_e_acsl_initialized) {
      int __gen_e_acsl_initialized_2;
      int __gen_e_acsl_and;
      int __gen_e_acsl_valid;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data,"*p",
                                   (void *)*p);
      __e_acsl_assert_data_t __gen_e_acsl_assert_data_2 =
        {.values = (void *)0};
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_2,"&p",
                                   (void *)(& p));
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_2,
                                     "sizeof(int **)",0,sizeof(int **));
      __gen_e_acsl_initialized_2 = __e_acsl_initialized((void *)(& p),
                                                        sizeof(int **));
      if (__gen_e_acsl_initialized_2) {
        int __gen_e_acsl_valid_read;
        __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_2,"p",
                                     (void *)p);
        __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_2,
                                       "sizeof(int *)",0,sizeof(int *));
        __gen_e_acsl_valid_read = __e_acsl_valid_read((void *)p,
                                                      sizeof(int *),
                                                      (void *)p,
                                                      (void *)(& p));
        __gen_e_acsl_and = __gen_e_acsl_valid_read;
      }
      else __gen_e_acsl_and = 0;
      __gen_e_acsl_assert_data_2.blocking = 1;
      __gen_e_acsl_assert_data_2.kind = "RTE";
      __gen_e_acsl_assert_data_2.pred_txt = "mem_access: \\valid_read(p)";
      __gen_e_acsl_assert_data_2.file = "tests/memory/valid.c";
      __gen_e_acsl_assert_data_2.fct = "g";
      __gen_e_acsl_assert_data_2.line = 24;
      __e_acsl_assert(__gen_e_acsl_and,& __gen_e_acsl_assert_data_2);
      __e_acsl_assert_clean(& __gen_e_acsl_assert_data_2);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data,
                                     "sizeof(int)",0,sizeof(int));
      __gen_e_acsl_valid = __e_acsl_valid((void *)*p,sizeof(int),(void *)*p,
                                          (void *)p);
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,"\\valid(*p)",
                                   0,__gen_e_acsl_valid);
      __gen_e_acsl_and_2 = __gen_e_acsl_valid;
    }
    else __gen_e_acsl_and_2 = 0;
    __gen_e_acsl_assert_data.blocking = 1;
    __gen_e_acsl_assert_data.kind = "Assertion";
    __gen_e_acsl_assert_data.pred_txt = "\\valid(*p)";
    __gen_e_acsl_assert_data.file = "tests/memory/valid.c";
    __gen_e_acsl_assert_data.fct = "g";
    __gen_e_acsl_assert_data.line = 24;
    __e_acsl_assert(__gen_e_acsl_and_2,& __gen_e_acsl_assert_data);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data);
  }
  /*@ assert \valid(*p); */ ;
  __e_acsl_delete_block((void *)(& p));
  __e_acsl_delete_block((void *)(& u));
  __e_acsl_delete_block((void *)(& m));
  return;
}

/*@ requires \valid(x);
    ensures \valid(\result); */
int *__gen_e_acsl_f(int *x)
{
  int *__retres;
  __e_acsl_store_block((void *)(& __retres),(size_t)8);
  {
    int __gen_e_acsl_valid;
    __e_acsl_store_block((void *)(& x),(size_t)8);
    __e_acsl_assert_data_t __gen_e_acsl_assert_data = {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data,"x",(void *)x);
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data,"sizeof(int)",
                                   0,sizeof(int));
    __gen_e_acsl_valid = __e_acsl_valid((void *)x,sizeof(int),(void *)x,
                                        (void *)(& x));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,"\\valid(x)",0,
                                 __gen_e_acsl_valid);
    __gen_e_acsl_assert_data.blocking = 1;
    __gen_e_acsl_assert_data.kind = "Precondition";
    __gen_e_acsl_assert_data.pred_txt = "\\valid(x)";
    __gen_e_acsl_assert_data.file = "tests/memory/valid.c";
    __gen_e_acsl_assert_data.fct = "f";
    __gen_e_acsl_assert_data.line = 9;
    __e_acsl_assert(__gen_e_acsl_valid,& __gen_e_acsl_assert_data);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data);
  }
  __retres = f(x);
  {
    int __gen_e_acsl_valid_2;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_2 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_2,"\\result",
                                 (void *)__retres);
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_2,
                                   "sizeof(int)",0,sizeof(int));
    __gen_e_acsl_valid_2 = __e_acsl_valid((void *)__retres,sizeof(int),
                                          (void *)__retres,
                                          (void *)(& __retres));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_2,
                                 "\\valid(\\result)",0,__gen_e_acsl_valid_2);
    __gen_e_acsl_assert_data_2.blocking = 1;
    __gen_e_acsl_assert_data_2.kind = "Postcondition";
    __gen_e_acsl_assert_data_2.pred_txt = "\\valid(\\result)";
    __gen_e_acsl_assert_data_2.file = "tests/memory/valid.c";
    __gen_e_acsl_assert_data_2.fct = "f";
    __gen_e_acsl_assert_data_2.line = 10;
    __e_acsl_assert(__gen_e_acsl_valid_2,& __gen_e_acsl_assert_data_2);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_2);
    __e_acsl_delete_block((void *)(& x));
    __e_acsl_delete_block((void *)(& __retres));
    return __retres;
  }
}

void __e_acsl_globals_init(void)
{
  static char __e_acsl_already_run = 0;
  if (! __e_acsl_already_run) {
    __e_acsl_already_run = 1;
    __e_acsl_store_block((void *)(& Z),(size_t)4);
    __e_acsl_full_init((void *)(& Z));
    __e_acsl_store_block((void *)(& X),(size_t)8);
    __e_acsl_full_init((void *)(& X));
  }
  return;
}

void __e_acsl_globals_clean(void)
{
  __e_acsl_delete_block((void *)(& Z));
  __e_acsl_delete_block((void *)(& X));
  return;
}

int main(void)
{
  int __retres;
  int *a;
  int *b;
  int **c;
  int ***d;
  __e_acsl_memory_init((int *)0,(char ***)0,(size_t)8);
  __e_acsl_globals_init();
  __e_acsl_store_block((void *)(& d),(size_t)8);
  __e_acsl_store_block((void *)(& c),(size_t)8);
  __e_acsl_store_block((void *)(& b),(size_t)8);
  __e_acsl_store_block((void *)(& a),(size_t)8);
  int n = 0;
  __e_acsl_store_block((void *)(& n),(size_t)4);
  __e_acsl_full_init((void *)(& n));
  {
    int __gen_e_acsl_initialized;
    int __gen_e_acsl_and;
    int __gen_e_acsl_and_3;
    int __gen_e_acsl_and_4;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data = {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data,"&a",
                                 (void *)(& a));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data,
                                   "sizeof(int *)",0,sizeof(int *));
    __gen_e_acsl_initialized = __e_acsl_initialized((void *)(& a),
                                                    sizeof(int *));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,
                                 "\\initialized(&a)",0,
                                 __gen_e_acsl_initialized);
    if (__gen_e_acsl_initialized) {
      int __gen_e_acsl_valid;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data,"a",(void *)a);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data,
                                     "sizeof(int)",0,sizeof(int));
      __gen_e_acsl_valid = __e_acsl_valid((void *)a,sizeof(int),(void *)a,
                                          (void *)(& a));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,"\\valid(a)",0,
                                   __gen_e_acsl_valid);
      __gen_e_acsl_and = __gen_e_acsl_valid;
    }
    else __gen_e_acsl_and = 0;
    if (! __gen_e_acsl_and) {
      int __gen_e_acsl_initialized_2;
      int __gen_e_acsl_and_2;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data,"&b",
                                   (void *)(& b));
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data,
                                     "sizeof(int *)",0,sizeof(int *));
      __gen_e_acsl_initialized_2 = __e_acsl_initialized((void *)(& b),
                                                        sizeof(int *));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,
                                   "\\initialized(&b)",0,
                                   __gen_e_acsl_initialized_2);
      if (__gen_e_acsl_initialized_2) {
        int __gen_e_acsl_valid_2;
        __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data,"b",
                                     (void *)b);
        __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data,
                                       "sizeof(int)",0,sizeof(int));
        __gen_e_acsl_valid_2 = __e_acsl_valid((void *)b,sizeof(int),
                                              (void *)b,(void *)(& b));
        __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,"\\valid(b)",
                                     0,__gen_e_acsl_valid_2);
        __gen_e_acsl_and_2 = __gen_e_acsl_valid_2;
      }
      else __gen_e_acsl_and_2 = 0;
      __gen_e_acsl_and_3 = ! __gen_e_acsl_and_2;
    }
    else __gen_e_acsl_and_3 = 0;
    if (__gen_e_acsl_and_3) {
      int __gen_e_acsl_valid_3;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data,"X",(void *)X);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data,
                                     "sizeof(int)",0,sizeof(int));
      __gen_e_acsl_valid_3 = __e_acsl_valid((void *)X,sizeof(int),(void *)X,
                                            (void *)(& X));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,"\\valid(X)",0,
                                   __gen_e_acsl_valid_3);
      __gen_e_acsl_and_4 = ! __gen_e_acsl_valid_3;
    }
    else __gen_e_acsl_and_4 = 0;
    __gen_e_acsl_assert_data.blocking = 1;
    __gen_e_acsl_assert_data.kind = "Assertion";
    __gen_e_acsl_assert_data.pred_txt = "!\\valid(a) && !\\valid(b) && !\\valid(X)";
    __gen_e_acsl_assert_data.file = "tests/memory/valid.c";
    __gen_e_acsl_assert_data.fct = "main";
    __gen_e_acsl_assert_data.line = 29;
    __e_acsl_assert(__gen_e_acsl_and_4,& __gen_e_acsl_assert_data);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data);
  }
  /*@ assert !\valid(a) && !\valid(b) && !\valid(X); */ ;
  __e_acsl_full_init((void *)(& a));
  a = (int *)malloc(sizeof(int));
  {
    int __gen_e_acsl_initialized_3;
    int __gen_e_acsl_and_5;
    int __gen_e_acsl_and_7;
    int __gen_e_acsl_and_8;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_2 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_2,"&a",
                                 (void *)(& a));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_2,
                                   "sizeof(int *)",0,sizeof(int *));
    __gen_e_acsl_initialized_3 = __e_acsl_initialized((void *)(& a),
                                                      sizeof(int *));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_2,
                                 "\\initialized(&a)",0,
                                 __gen_e_acsl_initialized_3);
    if (__gen_e_acsl_initialized_3) {
      int __gen_e_acsl_valid_4;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_2,"a",
                                   (void *)a);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_2,
                                     "sizeof(int)",0,sizeof(int));
      __gen_e_acsl_valid_4 = __e_acsl_valid((void *)a,sizeof(int),(void *)a,
                                            (void *)(& a));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_2,"\\valid(a)",
                                   0,__gen_e_acsl_valid_4);
      __gen_e_acsl_and_5 = __gen_e_acsl_valid_4;
    }
    else __gen_e_acsl_and_5 = 0;
    if (__gen_e_acsl_and_5) {
      int __gen_e_acsl_initialized_4;
      int __gen_e_acsl_and_6;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_2,"&b",
                                   (void *)(& b));
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_2,
                                     "sizeof(int *)",0,sizeof(int *));
      __gen_e_acsl_initialized_4 = __e_acsl_initialized((void *)(& b),
                                                        sizeof(int *));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_2,
                                   "\\initialized(&b)",0,
                                   __gen_e_acsl_initialized_4);
      if (__gen_e_acsl_initialized_4) {
        int __gen_e_acsl_valid_5;
        __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_2,"b",
                                     (void *)b);
        __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_2,
                                       "sizeof(int)",0,sizeof(int));
        __gen_e_acsl_valid_5 = __e_acsl_valid((void *)b,sizeof(int),
                                              (void *)b,(void *)(& b));
        __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_2,
                                     "\\valid(b)",0,__gen_e_acsl_valid_5);
        __gen_e_acsl_and_6 = __gen_e_acsl_valid_5;
      }
      else __gen_e_acsl_and_6 = 0;
      __gen_e_acsl_and_7 = ! __gen_e_acsl_and_6;
    }
    else __gen_e_acsl_and_7 = 0;
    if (__gen_e_acsl_and_7) {
      int __gen_e_acsl_valid_6;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_2,"X",
                                   (void *)X);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_2,
                                     "sizeof(int)",0,sizeof(int));
      __gen_e_acsl_valid_6 = __e_acsl_valid((void *)X,sizeof(int),(void *)X,
                                            (void *)(& X));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_2,"\\valid(X)",
                                   0,__gen_e_acsl_valid_6);
      __gen_e_acsl_and_8 = ! __gen_e_acsl_valid_6;
    }
    else __gen_e_acsl_and_8 = 0;
    __gen_e_acsl_assert_data_2.blocking = 1;
    __gen_e_acsl_assert_data_2.kind = "Assertion";
    __gen_e_acsl_assert_data_2.pred_txt = "\\valid(a) && !\\valid(b) && !\\valid(X)";
    __gen_e_acsl_assert_data_2.file = "tests/memory/valid.c";
    __gen_e_acsl_assert_data_2.fct = "main";
    __gen_e_acsl_assert_data_2.line = 31;
    __e_acsl_assert(__gen_e_acsl_and_8,& __gen_e_acsl_assert_data_2);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_2);
  }
  /*@ assert \valid(a) && !\valid(b) && !\valid(X); */ ;
  X = a;
  {
    int __gen_e_acsl_initialized_5;
    int __gen_e_acsl_and_9;
    int __gen_e_acsl_and_11;
    int __gen_e_acsl_and_12;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_3 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_3,"&a",
                                 (void *)(& a));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_3,
                                   "sizeof(int *)",0,sizeof(int *));
    __gen_e_acsl_initialized_5 = __e_acsl_initialized((void *)(& a),
                                                      sizeof(int *));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_3,
                                 "\\initialized(&a)",0,
                                 __gen_e_acsl_initialized_5);
    if (__gen_e_acsl_initialized_5) {
      int __gen_e_acsl_valid_7;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_3,"a",
                                   (void *)a);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_3,
                                     "sizeof(int)",0,sizeof(int));
      __gen_e_acsl_valid_7 = __e_acsl_valid((void *)a,sizeof(int),(void *)a,
                                            (void *)(& a));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_3,"\\valid(a)",
                                   0,__gen_e_acsl_valid_7);
      __gen_e_acsl_and_9 = __gen_e_acsl_valid_7;
    }
    else __gen_e_acsl_and_9 = 0;
    if (__gen_e_acsl_and_9) {
      int __gen_e_acsl_initialized_6;
      int __gen_e_acsl_and_10;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_3,"&b",
                                   (void *)(& b));
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_3,
                                     "sizeof(int *)",0,sizeof(int *));
      __gen_e_acsl_initialized_6 = __e_acsl_initialized((void *)(& b),
                                                        sizeof(int *));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_3,
                                   "\\initialized(&b)",0,
                                   __gen_e_acsl_initialized_6);
      if (__gen_e_acsl_initialized_6) {
        int __gen_e_acsl_valid_8;
        __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_3,"b",
                                     (void *)b);
        __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_3,
                                       "sizeof(int)",0,sizeof(int));
        __gen_e_acsl_valid_8 = __e_acsl_valid((void *)b,sizeof(int),
                                              (void *)b,(void *)(& b));
        __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_3,
                                     "\\valid(b)",0,__gen_e_acsl_valid_8);
        __gen_e_acsl_and_10 = __gen_e_acsl_valid_8;
      }
      else __gen_e_acsl_and_10 = 0;
      __gen_e_acsl_and_11 = ! __gen_e_acsl_and_10;
    }
    else __gen_e_acsl_and_11 = 0;
    if (__gen_e_acsl_and_11) {
      int __gen_e_acsl_valid_9;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_3,"X",
                                   (void *)X);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_3,
                                     "sizeof(int)",0,sizeof(int));
      __gen_e_acsl_valid_9 = __e_acsl_valid((void *)X,sizeof(int),(void *)X,
                                            (void *)(& X));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_3,"\\valid(X)",
                                   0,__gen_e_acsl_valid_9);
      __gen_e_acsl_and_12 = __gen_e_acsl_valid_9;
    }
    else __gen_e_acsl_and_12 = 0;
    __gen_e_acsl_assert_data_3.blocking = 1;
    __gen_e_acsl_assert_data_3.kind = "Assertion";
    __gen_e_acsl_assert_data_3.pred_txt = "\\valid(a) && !\\valid(b) && \\valid(X)";
    __gen_e_acsl_assert_data_3.file = "tests/memory/valid.c";
    __gen_e_acsl_assert_data_3.fct = "main";
    __gen_e_acsl_assert_data_3.line = 33;
    __e_acsl_assert(__gen_e_acsl_and_12,& __gen_e_acsl_assert_data_3);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_3);
  }
  /*@ assert \valid(a) && !\valid(b) && \valid(X); */ ;
  __e_acsl_full_init((void *)(& b));
  b = __gen_e_acsl_f(& n);
  {
    int __gen_e_acsl_initialized_7;
    int __gen_e_acsl_and_13;
    int __gen_e_acsl_and_15;
    int __gen_e_acsl_and_16;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_4 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_4,"&a",
                                 (void *)(& a));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_4,
                                   "sizeof(int *)",0,sizeof(int *));
    __gen_e_acsl_initialized_7 = __e_acsl_initialized((void *)(& a),
                                                      sizeof(int *));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_4,
                                 "\\initialized(&a)",0,
                                 __gen_e_acsl_initialized_7);
    if (__gen_e_acsl_initialized_7) {
      int __gen_e_acsl_valid_10;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_4,"a",
                                   (void *)a);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_4,
                                     "sizeof(int)",0,sizeof(int));
      __gen_e_acsl_valid_10 = __e_acsl_valid((void *)a,sizeof(int),(void *)a,
                                             (void *)(& a));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_4,"\\valid(a)",
                                   0,__gen_e_acsl_valid_10);
      __gen_e_acsl_and_13 = __gen_e_acsl_valid_10;
    }
    else __gen_e_acsl_and_13 = 0;
    if (__gen_e_acsl_and_13) {
      int __gen_e_acsl_initialized_8;
      int __gen_e_acsl_and_14;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_4,"&b",
                                   (void *)(& b));
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_4,
                                     "sizeof(int *)",0,sizeof(int *));
      __gen_e_acsl_initialized_8 = __e_acsl_initialized((void *)(& b),
                                                        sizeof(int *));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_4,
                                   "\\initialized(&b)",0,
                                   __gen_e_acsl_initialized_8);
      if (__gen_e_acsl_initialized_8) {
        int __gen_e_acsl_valid_11;
        __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_4,"b",
                                     (void *)b);
        __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_4,
                                       "sizeof(int)",0,sizeof(int));
        __gen_e_acsl_valid_11 = __e_acsl_valid((void *)b,sizeof(int),
                                               (void *)b,(void *)(& b));
        __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_4,
                                     "\\valid(b)",0,__gen_e_acsl_valid_11);
        __gen_e_acsl_and_14 = __gen_e_acsl_valid_11;
      }
      else __gen_e_acsl_and_14 = 0;
      __gen_e_acsl_and_15 = __gen_e_acsl_and_14;
    }
    else __gen_e_acsl_and_15 = 0;
    if (__gen_e_acsl_and_15) {
      int __gen_e_acsl_valid_12;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_4,"X",
                                   (void *)X);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_4,
                                     "sizeof(int)",0,sizeof(int));
      __gen_e_acsl_valid_12 = __e_acsl_valid((void *)X,sizeof(int),(void *)X,
                                             (void *)(& X));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_4,"\\valid(X)",
                                   0,__gen_e_acsl_valid_12);
      __gen_e_acsl_and_16 = __gen_e_acsl_valid_12;
    }
    else __gen_e_acsl_and_16 = 0;
    __gen_e_acsl_assert_data_4.blocking = 1;
    __gen_e_acsl_assert_data_4.kind = "Assertion";
    __gen_e_acsl_assert_data_4.pred_txt = "\\valid(a) && \\valid(b) && \\valid(X)";
    __gen_e_acsl_assert_data_4.file = "tests/memory/valid.c";
    __gen_e_acsl_assert_data_4.fct = "main";
    __gen_e_acsl_assert_data_4.line = 35;
    __e_acsl_assert(__gen_e_acsl_and_16,& __gen_e_acsl_assert_data_4);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_4);
  }
  /*@ assert \valid(a) && \valid(b) && \valid(X); */ ;
  X = b;
  {
    int __gen_e_acsl_initialized_9;
    int __gen_e_acsl_and_17;
    int __gen_e_acsl_and_19;
    int __gen_e_acsl_and_20;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_5 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_5,"&a",
                                 (void *)(& a));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_5,
                                   "sizeof(int *)",0,sizeof(int *));
    __gen_e_acsl_initialized_9 = __e_acsl_initialized((void *)(& a),
                                                      sizeof(int *));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_5,
                                 "\\initialized(&a)",0,
                                 __gen_e_acsl_initialized_9);
    if (__gen_e_acsl_initialized_9) {
      int __gen_e_acsl_valid_13;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_5,"a",
                                   (void *)a);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_5,
                                     "sizeof(int)",0,sizeof(int));
      __gen_e_acsl_valid_13 = __e_acsl_valid((void *)a,sizeof(int),(void *)a,
                                             (void *)(& a));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_5,"\\valid(a)",
                                   0,__gen_e_acsl_valid_13);
      __gen_e_acsl_and_17 = __gen_e_acsl_valid_13;
    }
    else __gen_e_acsl_and_17 = 0;
    if (__gen_e_acsl_and_17) {
      int __gen_e_acsl_initialized_10;
      int __gen_e_acsl_and_18;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_5,"&b",
                                   (void *)(& b));
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_5,
                                     "sizeof(int *)",0,sizeof(int *));
      __gen_e_acsl_initialized_10 = __e_acsl_initialized((void *)(& b),
                                                         sizeof(int *));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_5,
                                   "\\initialized(&b)",0,
                                   __gen_e_acsl_initialized_10);
      if (__gen_e_acsl_initialized_10) {
        int __gen_e_acsl_valid_14;
        __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_5,"b",
                                     (void *)b);
        __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_5,
                                       "sizeof(int)",0,sizeof(int));
        __gen_e_acsl_valid_14 = __e_acsl_valid((void *)b,sizeof(int),
                                               (void *)b,(void *)(& b));
        __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_5,
                                     "\\valid(b)",0,__gen_e_acsl_valid_14);
        __gen_e_acsl_and_18 = __gen_e_acsl_valid_14;
      }
      else __gen_e_acsl_and_18 = 0;
      __gen_e_acsl_and_19 = __gen_e_acsl_and_18;
    }
    else __gen_e_acsl_and_19 = 0;
    if (__gen_e_acsl_and_19) {
      int __gen_e_acsl_valid_15;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_5,"X",
                                   (void *)X);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_5,
                                     "sizeof(int)",0,sizeof(int));
      __gen_e_acsl_valid_15 = __e_acsl_valid((void *)X,sizeof(int),(void *)X,
                                             (void *)(& X));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_5,"\\valid(X)",
                                   0,__gen_e_acsl_valid_15);
      __gen_e_acsl_and_20 = __gen_e_acsl_valid_15;
    }
    else __gen_e_acsl_and_20 = 0;
    __gen_e_acsl_assert_data_5.blocking = 1;
    __gen_e_acsl_assert_data_5.kind = "Assertion";
    __gen_e_acsl_assert_data_5.pred_txt = "\\valid(a) && \\valid(b) && \\valid(X)";
    __gen_e_acsl_assert_data_5.file = "tests/memory/valid.c";
    __gen_e_acsl_assert_data_5.fct = "main";
    __gen_e_acsl_assert_data_5.line = 37;
    __e_acsl_assert(__gen_e_acsl_and_20,& __gen_e_acsl_assert_data_5);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_5);
  }
  /*@ assert \valid(a) && \valid(b) && \valid(X); */ ;
  __e_acsl_full_init((void *)(& c));
  c = & a;
  __e_acsl_full_init((void *)(& d));
  d = & c;
  {
    int __gen_e_acsl_initialized_11;
    int __gen_e_acsl_and_22;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_6 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_6,"c",(void *)c);
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_6,
                                   "sizeof(int *)",0,sizeof(int *));
    __gen_e_acsl_initialized_11 = __e_acsl_initialized((void *)c,
                                                       sizeof(int *));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_6,
                                 "\\initialized(c)",0,
                                 __gen_e_acsl_initialized_11);
    if (__gen_e_acsl_initialized_11) {
      int __gen_e_acsl_initialized_12;
      int __gen_e_acsl_and_21;
      int __gen_e_acsl_valid_16;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_6,"*c",
                                   (void *)*c);
      __e_acsl_assert_data_t __gen_e_acsl_assert_data_7 =
        {.values = (void *)0};
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_7,"&c",
                                   (void *)(& c));
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_7,
                                     "sizeof(int **)",0,sizeof(int **));
      __gen_e_acsl_initialized_12 = __e_acsl_initialized((void *)(& c),
                                                         sizeof(int **));
      if (__gen_e_acsl_initialized_12) {
        int __gen_e_acsl_valid_read;
        __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_7,"c",
                                     (void *)c);
        __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_7,
                                       "sizeof(int *)",0,sizeof(int *));
        __gen_e_acsl_valid_read = __e_acsl_valid_read((void *)c,
                                                      sizeof(int *),
                                                      (void *)c,
                                                      (void *)(& c));
        __gen_e_acsl_and_21 = __gen_e_acsl_valid_read;
      }
      else __gen_e_acsl_and_21 = 0;
      __gen_e_acsl_assert_data_7.blocking = 1;
      __gen_e_acsl_assert_data_7.kind = "RTE";
      __gen_e_acsl_assert_data_7.pred_txt = "mem_access: \\valid_read(c)";
      __gen_e_acsl_assert_data_7.file = "tests/memory/valid.c";
      __gen_e_acsl_assert_data_7.fct = "main";
      __gen_e_acsl_assert_data_7.line = 40;
      __e_acsl_assert(__gen_e_acsl_and_21,& __gen_e_acsl_assert_data_7);
      __e_acsl_assert_clean(& __gen_e_acsl_assert_data_7);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_6,
                                     "sizeof(int)",0,sizeof(int));
      __gen_e_acsl_valid_16 = __e_acsl_valid((void *)*c,sizeof(int),
                                             (void *)*c,(void *)c);
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_6,
                                   "\\valid(*c)",0,__gen_e_acsl_valid_16);
      __gen_e_acsl_and_22 = __gen_e_acsl_valid_16;
    }
    else __gen_e_acsl_and_22 = 0;
    __gen_e_acsl_assert_data_6.blocking = 1;
    __gen_e_acsl_assert_data_6.kind = "Assertion";
    __gen_e_acsl_assert_data_6.pred_txt = "\\valid(*c)";
    __gen_e_acsl_assert_data_6.file = "tests/memory/valid.c";
    __gen_e_acsl_assert_data_6.fct = "main";
    __gen_e_acsl_assert_data_6.line = 40;
    __e_acsl_assert(__gen_e_acsl_and_22,& __gen_e_acsl_assert_data_6);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_6);
  }
  /*@ assert \valid(*c); */ ;
  {
    int __gen_e_acsl_initialized_13;
    int __gen_e_acsl_and_23;
    int __gen_e_acsl_initialized_14;
    int __gen_e_acsl_and_27;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_8 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_8,"*d",
                                 (void *)*d);
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_9 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_9,"&d",
                                 (void *)(& d));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_9,
                                   "sizeof(int ***)",0,sizeof(int ***));
    __gen_e_acsl_initialized_13 = __e_acsl_initialized((void *)(& d),
                                                       sizeof(int ***));
    if (__gen_e_acsl_initialized_13) {
      int __gen_e_acsl_valid_read_2;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_9,"d",
                                   (void *)d);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_9,
                                     "sizeof(int **)",0,sizeof(int **));
      __gen_e_acsl_valid_read_2 = __e_acsl_valid_read((void *)d,
                                                      sizeof(int **),
                                                      (void *)d,
                                                      (void *)(& d));
      __gen_e_acsl_and_23 = __gen_e_acsl_valid_read_2;
    }
    else __gen_e_acsl_and_23 = 0;
    __gen_e_acsl_assert_data_9.blocking = 1;
    __gen_e_acsl_assert_data_9.kind = "RTE";
    __gen_e_acsl_assert_data_9.pred_txt = "mem_access: \\valid_read(d)";
    __gen_e_acsl_assert_data_9.file = "tests/memory/valid.c";
    __gen_e_acsl_assert_data_9.fct = "main";
    __gen_e_acsl_assert_data_9.line = 41;
    __e_acsl_assert(__gen_e_acsl_and_23,& __gen_e_acsl_assert_data_9);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_9);
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_8,
                                   "sizeof(int *)",0,sizeof(int *));
    __gen_e_acsl_initialized_14 = __e_acsl_initialized((void *)*d,
                                                       sizeof(int *));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_8,
                                 "\\initialized(*d)",0,
                                 __gen_e_acsl_initialized_14);
    if (__gen_e_acsl_initialized_14) {
      int __gen_e_acsl_initialized_15;
      int __gen_e_acsl_and_25;
      int __gen_e_acsl_initialized_17;
      int __gen_e_acsl_and_26;
      int __gen_e_acsl_valid_17;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_8,"*(*d)",
                                   (void *)*(*d));
      __e_acsl_assert_data_t __gen_e_acsl_assert_data_10 =
        {.values = (void *)0};
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_10,"d",
                                   (void *)d);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_10,
                                     "sizeof(int **)",0,sizeof(int **));
      __gen_e_acsl_initialized_15 = __e_acsl_initialized((void *)d,
                                                         sizeof(int **));
      if (__gen_e_acsl_initialized_15) {
        int __gen_e_acsl_initialized_16;
        int __gen_e_acsl_and_24;
        int __gen_e_acsl_valid_read_4;
        __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_10,"*d",
                                     (void *)*d);
        __e_acsl_assert_data_t __gen_e_acsl_assert_data_11 =
          {.values = (void *)0};
        __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_11,"&d",
                                     (void *)(& d));
        __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_11,
                                       "sizeof(int ***)",0,sizeof(int ***));
        __gen_e_acsl_initialized_16 = __e_acsl_initialized((void *)(& d),
                                                           sizeof(int ***));
        if (__gen_e_acsl_initialized_16) {
          int __gen_e_acsl_valid_read_3;
          __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_11,"d",
                                       (void *)d);
          __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_11,
                                         "sizeof(int **)",0,sizeof(int **));
          __gen_e_acsl_valid_read_3 = __e_acsl_valid_read((void *)d,
                                                          sizeof(int **),
                                                          (void *)d,
                                                          (void *)(& d));
          __gen_e_acsl_and_24 = __gen_e_acsl_valid_read_3;
        }
        else __gen_e_acsl_and_24 = 0;
        __gen_e_acsl_assert_data_11.blocking = 1;
        __gen_e_acsl_assert_data_11.kind = "RTE";
        __gen_e_acsl_assert_data_11.pred_txt = "mem_access: \\valid_read(d)";
        __gen_e_acsl_assert_data_11.file = "tests/memory/valid.c";
        __gen_e_acsl_assert_data_11.fct = "main";
        __gen_e_acsl_assert_data_11.line = 41;
        __e_acsl_assert(__gen_e_acsl_and_24,& __gen_e_acsl_assert_data_11);
        __e_acsl_assert_clean(& __gen_e_acsl_assert_data_11);
        __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_10,
                                       "sizeof(int *)",0,sizeof(int *));
        __gen_e_acsl_valid_read_4 = __e_acsl_valid_read((void *)*d,
                                                        sizeof(int *),
                                                        (void *)*d,(void *)d);
        __gen_e_acsl_and_25 = __gen_e_acsl_valid_read_4;
      }
      else __gen_e_acsl_and_25 = 0;
      __gen_e_acsl_assert_data_10.blocking = 1;
      __gen_e_acsl_assert_data_10.kind = "RTE";
      __gen_e_acsl_assert_data_10.pred_txt = "mem_access: \\valid_read(*d)";
      __gen_e_acsl_assert_data_10.file = "tests/memory/valid.c";
      __gen_e_acsl_assert_data_10.fct = "main";
      __gen_e_acsl_assert_data_10.line = 41;
      __e_acsl_assert(__gen_e_acsl_and_25,& __gen_e_acsl_assert_data_10);
      __e_acsl_assert_clean(& __gen_e_acsl_assert_data_10);
      __e_acsl_assert_data_t __gen_e_acsl_assert_data_12 =
        {.values = (void *)0};
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_12,"&d",
                                   (void *)(& d));
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_12,
                                     "sizeof(int ***)",0,sizeof(int ***));
      __gen_e_acsl_initialized_17 = __e_acsl_initialized((void *)(& d),
                                                         sizeof(int ***));
      if (__gen_e_acsl_initialized_17) {
        int __gen_e_acsl_valid_read_5;
        __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_12,"d",
                                     (void *)d);
        __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_12,
                                       "sizeof(int **)",0,sizeof(int **));
        __gen_e_acsl_valid_read_5 = __e_acsl_valid_read((void *)d,
                                                        sizeof(int **),
                                                        (void *)d,
                                                        (void *)(& d));
        __gen_e_acsl_and_26 = __gen_e_acsl_valid_read_5;
      }
      else __gen_e_acsl_and_26 = 0;
      __gen_e_acsl_assert_data_12.blocking = 1;
      __gen_e_acsl_assert_data_12.kind = "RTE";
      __gen_e_acsl_assert_data_12.pred_txt = "mem_access: \\valid_read(d)";
      __gen_e_acsl_assert_data_12.file = "tests/memory/valid.c";
      __gen_e_acsl_assert_data_12.fct = "main";
      __gen_e_acsl_assert_data_12.line = 41;
      __e_acsl_assert(__gen_e_acsl_and_26,& __gen_e_acsl_assert_data_12);
      __e_acsl_assert_clean(& __gen_e_acsl_assert_data_12);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_8,
                                     "sizeof(int)",0,sizeof(int));
      __gen_e_acsl_valid_17 = __e_acsl_valid((void *)*(*d),sizeof(int),
                                             (void *)*(*d),(void *)*d);
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_8,
                                   "\\valid(*(*d))",0,__gen_e_acsl_valid_17);
      __gen_e_acsl_and_27 = __gen_e_acsl_valid_17;
    }
    else __gen_e_acsl_and_27 = 0;
    __gen_e_acsl_assert_data_8.blocking = 1;
    __gen_e_acsl_assert_data_8.kind = "Assertion";
    __gen_e_acsl_assert_data_8.pred_txt = "\\valid(*(*d))";
    __gen_e_acsl_assert_data_8.file = "tests/memory/valid.c";
    __gen_e_acsl_assert_data_8.fct = "main";
    __gen_e_acsl_assert_data_8.line = 41;
    __e_acsl_assert(__gen_e_acsl_and_27,& __gen_e_acsl_assert_data_8);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_8);
  }
  /*@ assert \valid(*(*d)); */ ;
  free((void *)a);
  {
    int __gen_e_acsl_initialized_18;
    int __gen_e_acsl_and_28;
    int __gen_e_acsl_and_30;
    int __gen_e_acsl_and_31;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_13 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_13,"&a",
                                 (void *)(& a));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_13,
                                   "sizeof(int *)",0,sizeof(int *));
    __gen_e_acsl_initialized_18 = __e_acsl_initialized((void *)(& a),
                                                       sizeof(int *));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_13,
                                 "\\initialized(&a)",0,
                                 __gen_e_acsl_initialized_18);
    if (__gen_e_acsl_initialized_18) {
      int __gen_e_acsl_valid_18;
      /*@ assert Eva: dangling_pointer: !\dangling(&a); */
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_13,"a",
                                   (void *)a);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_13,
                                     "sizeof(int)",0,sizeof(int));
      __gen_e_acsl_valid_18 = __e_acsl_valid((void *)a,sizeof(int),(void *)a,
                                             (void *)(& a));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_13,
                                   "\\valid(a)",0,__gen_e_acsl_valid_18);
      __gen_e_acsl_and_28 = __gen_e_acsl_valid_18;
    }
    else __gen_e_acsl_and_28 = 0;
    if (! __gen_e_acsl_and_28) {
      int __gen_e_acsl_initialized_19;
      int __gen_e_acsl_and_29;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_13,"&b",
                                   (void *)(& b));
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_13,
                                     "sizeof(int *)",0,sizeof(int *));
      __gen_e_acsl_initialized_19 = __e_acsl_initialized((void *)(& b),
                                                         sizeof(int *));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_13,
                                   "\\initialized(&b)",0,
                                   __gen_e_acsl_initialized_19);
      if (__gen_e_acsl_initialized_19) {
        int __gen_e_acsl_valid_19;
        __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_13,"b",
                                     (void *)b);
        __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_13,
                                       "sizeof(int)",0,sizeof(int));
        __gen_e_acsl_valid_19 = __e_acsl_valid((void *)b,sizeof(int),
                                               (void *)b,(void *)(& b));
        __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_13,
                                     "\\valid(b)",0,__gen_e_acsl_valid_19);
        __gen_e_acsl_and_29 = __gen_e_acsl_valid_19;
      }
      else __gen_e_acsl_and_29 = 0;
      __gen_e_acsl_and_30 = __gen_e_acsl_and_29;
    }
    else __gen_e_acsl_and_30 = 0;
    if (__gen_e_acsl_and_30) {
      int __gen_e_acsl_valid_20;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_13,"X",
                                   (void *)X);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_13,
                                     "sizeof(int)",0,sizeof(int));
      __gen_e_acsl_valid_20 = __e_acsl_valid((void *)X,sizeof(int),(void *)X,
                                             (void *)(& X));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_13,
                                   "\\valid(X)",0,__gen_e_acsl_valid_20);
      __gen_e_acsl_and_31 = __gen_e_acsl_valid_20;
    }
    else __gen_e_acsl_and_31 = 0;
    __gen_e_acsl_assert_data_13.blocking = 1;
    __gen_e_acsl_assert_data_13.kind = "Assertion";
    __gen_e_acsl_assert_data_13.pred_txt = "!\\valid(a) && \\valid(b) && \\valid(X)";
    __gen_e_acsl_assert_data_13.file = "tests/memory/valid.c";
    __gen_e_acsl_assert_data_13.fct = "main";
    __gen_e_acsl_assert_data_13.line = 43;
    __e_acsl_assert(__gen_e_acsl_and_31,& __gen_e_acsl_assert_data_13);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_13);
  }
  /*@ assert !\valid(a) && \valid(b) && \valid(X); */ ;
  {
    int __gen_e_acsl_valid_21;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_14 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_14,"&Z",
                                 (void *)(& Z));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_14,
                                   "sizeof(int)",0,sizeof(int));
    __gen_e_acsl_valid_21 = __e_acsl_valid((void *)(& Z),sizeof(int),
                                           (void *)(& Z),(void *)0);
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_14,"\\valid(&Z)",
                                 0,__gen_e_acsl_valid_21);
    __gen_e_acsl_assert_data_14.blocking = 1;
    __gen_e_acsl_assert_data_14.kind = "Assertion";
    __gen_e_acsl_assert_data_14.pred_txt = "\\valid(&Z)";
    __gen_e_acsl_assert_data_14.file = "tests/memory/valid.c";
    __gen_e_acsl_assert_data_14.fct = "main";
    __gen_e_acsl_assert_data_14.line = 44;
    __e_acsl_assert(__gen_e_acsl_valid_21,& __gen_e_acsl_assert_data_14);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_14);
  }
  /*@ assert \valid(&Z); */ ;
  g();
  __retres = 0;
  __e_acsl_delete_block((void *)(& n));
  __e_acsl_delete_block((void *)(& d));
  __e_acsl_delete_block((void *)(& c));
  __e_acsl_delete_block((void *)(& b));
  __e_acsl_delete_block((void *)(& a));
  __e_acsl_globals_clean();
  __e_acsl_memory_clean();
  return __retres;
}


